<script setup lang="ts">
import { reactive } from "vue";
import { useUsers } from "../stores/useUsers";
import EditUserButton from "./EditUserButton.vue";
import DeleteUserButton from "./DeleteUserButton.vue";
import UserEditModal from "./UserEditModal.vue";
import UserDeleteModal from "./UserDeleteModal.vue";
import { capitalize } from "../../../utils/typography";
import type { TUser } from "../types/user.type";

const modalEditUser = reactive<
  { open: true; user: TUser } | { open: false; user: null }
>({ open: false, user: null });
const modalDeleteUser = reactive<
  { open: true; user: TUser } | { open: false; user: null }
>({ open: false, user: null });

const store = useUsers();

function handleClickEditUser(id: TUser["id"]) {
  const user = store.users.find((u) => u.id === id);
  if (user) {
    modalEditUser.open = true;
    modalEditUser.user = user;
  }
}

function handleClickDeleteUser(id: TUser["id"]) {
  const user = store.users.find((u) => u.id === id);
  if (user) {
    modalDeleteUser.open = true;
    modalDeleteUser.user = user;
  }
}

function handleSaveEditUser(user: TUser) {
  store.editUser(user.id, user);
  modalEditUser.open = false;
  modalEditUser.user = null;
}

function handleCancelEditUser() {
  modalEditUser.open = false;
  modalEditUser.user = null;
}

function handleCancelDeleteUser() {
  modalDeleteUser.open = false;
  modalDeleteUser.user = null;
}
</script>

<template>
  <section class="@container">
    <table class="w-full table-auto">
      <thead class="border-b">
        <tr>
          <th class="px-2 py-4 text-left">Name</th>
          <th class="px-2 py-4 text-left">Title</th>
          <th class="hidden px-2 py-4 text-left @3xl:table-cell">Email</th>
          <th class="hidden px-2 py-4 text-left @xl:table-cell">Role</th>
          <th></th>
        </tr>
      </thead>
      <tbody class="divide-y">
        <tr v-for="user in store.users">
          <td class="p-2 py-3">{{ user.name }}</td>
          <td class="p-2 py-3 font-light">{{ user.title }}</td>
          <td class="hidden p-2 py-3 font-light @3xl:table-cell">
            {{ user.email }}
          </td>
          <td class="hidden p-2 py-3 font-light @xl:table-cell">
            {{ capitalize(user.role) }}
          </td>
          <td class="flex items-center justify-start gap-2 p-2 py-3">
            <EditUserButton :id="user.id" @click="handleClickEditUser" />
            <DeleteUserButton :id="user.id" @click="handleClickDeleteUser" />
          </td>
        </tr>
      </tbody>
    </table>
  </section>

  <UserEditModal
    v-if="modalEditUser.open"
    :open="modalEditUser.open"
    :user="modalEditUser.user!"
    @save="handleSaveEditUser"
    @close="handleCancelEditUser"
  />

  <UserDeleteModal
    v-if="modalDeleteUser.open"
    :open="modalDeleteUser.open"
    :user="modalDeleteUser.user!"
    @close="handleCancelDeleteUser"
  />
</template>
